#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Reflection;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Edit;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Tools.XPMenus;

namespace VSDemo
{
	public enum EditorType
	{
		CS,
		VB
	}

	/// <summary>
	/// Summary description for EditorBase.
	/// </summary>
	public class EditorBase : System.Windows.Forms.Form, IEditor
	{
		private System.ComponentModel.IContainer components;
		private string sourceFile = String.Empty;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager childFrameBarManager1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem undoItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem redoItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem copyItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem cutItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem pasteItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ImageList largeImageList;
		public Syncfusion.Windows.Forms.Edit.EditControl editControl;
		protected bool dirty = false;
		static string exePath = "";
		private Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem comboBoxBarItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem4;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem5;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem6;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem7;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem8;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem9;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem10;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem11;
		private Syncfusion.Windows.Forms.Tools.XPMenus.DropDownBarItem dropDownBarItem1;
		private System.Windows.Forms.ListBox listBox1;
		private Syncfusion.Windows.Forms.PopupControlContainer undoPopup;
		private System.Windows.Forms.Label undoLabel;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar3;
		private EditorType editorType;

		// Mandatory implementation: Expose the bar manager to the framework
		public BarManager BarManager
		{
			get{return this.childFrameBarManager1;}
		}

		public EditorBase()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			exePath = Assembly.GetEntryAssembly().Location;
			int loc = exePath.LastIndexOf("\\");
			exePath = exePath.Substring(0, loc);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			//this.editControl = new EditControl();
		}

		public EditorBase(string sourceFile, EditorType editoryType)
			: this()
		{
			this.sourceFile = sourceFile;
			this.editorType = editoryType;			
			//if(editorType == EditorType.CS)
			//	this.editControl.SettingFile = "*CSharp.ini";
			//else
			//	this.editControl.SettingFile = "*VB.ini";
		}

		public EditorType EditorType
		{
			get{return this.editorType;}
			set{this.editorType = value;}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(EditorBase));
			this.childFrameBarManager1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager(this.components, this);
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager1, "MainMenu");
			this.parentBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.undoItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.dropDownBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.DropDownBarItem();
			this.undoPopup = new Syncfusion.Windows.Forms.PopupControlContainer();
			this.undoLabel = new System.Windows.Forms.Label();
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.redoItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.cutItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.copyItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.pasteItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.comboBoxBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem();
			this.barItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItem8 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem9 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem10 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem11 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem5 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem6 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem7 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.bar2 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager1, "Text Editor 1");
			this.bar3 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager1, "Text Editor 2");
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.largeImageList = new System.Windows.Forms.ImageList(this.components);
			this.editControl = new Syncfusion.Windows.Forms.Edit.EditControl();
			((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager1)).BeginInit();
			this.undoPopup.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.editControl)).BeginInit();
			this.SuspendLayout();
			// 
			// childFrameBarManager1
			// 
			this.childFrameBarManager1.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("childFrameBarManager1.BarPositionInfo")));
			this.childFrameBarManager1.Bars.Add(this.bar1);
			this.childFrameBarManager1.Bars.Add(this.bar2);
			this.childFrameBarManager1.Bars.Add(this.bar3);
			this.childFrameBarManager1.Categories.Add("Edit");
			this.childFrameBarManager1.Categories.Add("Bookmarks");
			this.childFrameBarManager1.Categories.Add("Advanced");
			this.childFrameBarManager1.CurrentBaseFormType = "System.Windows.Forms.Form";
			this.childFrameBarManager1.Form = this;
			this.childFrameBarManager1.ImageList = this.imageList1;
			this.childFrameBarManager1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											   this.parentBarItem2,
																											   this.parentBarItem1,
																											   this.barItem4,
																											   this.undoItem,
																											   this.barItem5,
																											   this.redoItem,
																											   this.barItem6,
																											   this.cutItem,
																											   this.barItem7,
																											   this.copyItem,
																											   this.pasteItem,
																											   this.barItem2,
																											   this.barItem1,
																											   this.comboBoxBarItem1,
																											   this.barItem3,
																											   this.dropDownBarItem1,
																											   this.parentBarItem3,
																											   this.barItem8,
																											   this.barItem9,
																											   this.barItem10,
																											   this.barItem11});
			this.childFrameBarManager1.LargeImageList = this.largeImageList;
			// 
			// bar1
			// 
			this.bar1.BarName = "MainMenu";
			this.bar1.BarStyle = (((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder);
			this.bar1.Caption = "MainMenu";
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.parentBarItem1});
			this.bar1.Manager = this.childFrameBarManager1;
			// 
			// parentBarItem1
			// 
			this.parentBarItem1.CategoryIndex = 0;
			this.parentBarItem1.ID = "&Edit";
			this.parentBarItem1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.undoItem,
																										this.dropDownBarItem1,
																										this.redoItem,
																										this.cutItem,
																										this.copyItem,
																										this.pasteItem,
																										this.comboBoxBarItem1,
																										this.barItem3,
																										this.barItem2,
																										this.barItem1,
																										this.parentBarItem3,
																										this.parentBarItem2});
			this.parentBarItem1.MergeOrder = 6;
			this.parentBarItem1.SeparatorIndices.AddRange(new int[] {
																		2,
																		5,
																		7,
																		9});
			this.parentBarItem1.Text = "&Edit";
			// 
			// undoItem
			// 
			this.undoItem.CategoryIndex = 0;
			this.undoItem.ID = "&Undo";
			this.undoItem.ImageIndex = 3;
			this.undoItem.Shortcut = System.Windows.Forms.Shortcut.CtrlZ;
			this.undoItem.Text = "&Undo";
			this.undoItem.Click += new System.EventHandler(this.OnUndo);
			// 
			// dropDownBarItem1
			// 
			this.dropDownBarItem1.CategoryIndex = 0;
			this.dropDownBarItem1.ID = "Undo";
			this.dropDownBarItem1.ImageIndex = 3;
			this.dropDownBarItem1.PopupControlContainer = this.undoPopup;
			this.dropDownBarItem1.Text = "Undo";
			// 
			// undoPopup
			// 
			this.undoPopup.BackColor = System.Drawing.SystemColors.Window;
			this.undoPopup.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.undoLabel,
																					this.listBox1});
			this.undoPopup.DockPadding.All = 1;
			this.undoPopup.Location = new System.Drawing.Point(112, 104);
			this.undoPopup.Name = "undoPopup";
			this.undoPopup.Size = new System.Drawing.Size(120, 104);
			this.undoPopup.TabIndex = 5;
			this.undoPopup.Visible = false;
			this.undoPopup.BeforePopup += new System.ComponentModel.CancelEventHandler(this.undoPopup_BeforePopup);
			this.undoPopup.CloseUp += new Syncfusion.Windows.Forms.PopupClosedEventHandler(this.undoPopup_CloseUp);
			// 
			// undoLabel
			// 
			this.undoLabel.BackColor = System.Drawing.Color.WhiteSmoke;
			this.undoLabel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.undoLabel.Location = new System.Drawing.Point(1, 79);
			this.undoLabel.Name = "undoLabel";
			this.undoLabel.Size = new System.Drawing.Size(118, 24);
			this.undoLabel.TabIndex = 1;
			this.undoLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.undoLabel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.label1_MouseDown);
			// 
			// listBox1
			// 
			this.listBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.listBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.listBox1.Items.AddRange(new object[] {
														  "One",
														  "Two",
														  "Three",
														  "Four",
														  "Five"});
			this.listBox1.Location = new System.Drawing.Point(1, 1);
			this.listBox1.Name = "listBox1";
			this.listBox1.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple;
			this.listBox1.Size = new System.Drawing.Size(118, 78);
			this.listBox1.TabIndex = 0;
			this.listBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.MultipleUndo);
			this.listBox1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.listBox1_MouseUp);
			this.listBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.listBox1_MouseMove);
			// 
			// redoItem
			// 
			this.redoItem.CategoryIndex = 0;
			this.redoItem.ID = "&Redo";
			this.redoItem.ImageIndex = 4;
			this.redoItem.Shortcut = System.Windows.Forms.Shortcut.CtrlY;
			this.redoItem.Text = "&Redo";
			this.redoItem.Click += new System.EventHandler(this.OnRedo);
			// 
			// cutItem
			// 
			this.cutItem.CategoryIndex = 0;
			this.cutItem.ID = "Cu&t";
			this.cutItem.ImageIndex = 0;
			this.cutItem.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.cutItem.Text = "Cu&t";
			this.cutItem.Click += new System.EventHandler(this.OnCut);
			// 
			// copyItem
			// 
			this.copyItem.CategoryIndex = 0;
			this.copyItem.ID = "&Copy";
			this.copyItem.ImageIndex = 1;
			this.copyItem.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.copyItem.Text = "&Copy";
			this.copyItem.Click += new System.EventHandler(this.OnCopy);
			// 
			// pasteItem
			// 
			this.pasteItem.CategoryIndex = 0;
			this.pasteItem.ID = "&Paste";
			this.pasteItem.ImageIndex = 2;
			this.pasteItem.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.pasteItem.Text = "&Paste";
			this.pasteItem.Click += new System.EventHandler(this.OnPaste);
			// 
			// comboBoxBarItem1
			// 
			this.comboBoxBarItem1.AutoAppend = true;
			this.comboBoxBarItem1.CategoryIndex = 0;
			this.comboBoxBarItem1.ID = "Find";
			this.comboBoxBarItem1.MinWidth = 100;
			this.comboBoxBarItem1.Text = "Find";
			this.comboBoxBarItem1.Click += new System.EventHandler(this.find_Click);
			// 
			// barItem3
			// 
			this.barItem3.CategoryIndex = 0;
			this.barItem3.ID = "Find and Replace";
			this.barItem3.Shortcut = System.Windows.Forms.Shortcut.CtrlF;
			this.barItem3.Text = "Find and Replace";
			this.barItem3.Click += new System.EventHandler(this.OnFindReplace);
			// 
			// barItem2
			// 
			this.barItem2.CategoryIndex = 0;
			this.barItem2.ID = "&Delete";
			this.barItem2.Shortcut = System.Windows.Forms.Shortcut.Del;
			this.barItem2.Text = "&Delete";
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = 0;
			this.barItem1.ID = "Select &All";
			this.barItem1.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
			this.barItem1.Text = "Select &All";
			// 
			// parentBarItem3
			// 
			this.parentBarItem3.CategoryIndex = 2;
			this.parentBarItem3.ID = "Advanced";
			this.parentBarItem3.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItem8,
																										this.barItem9,
																										this.barItem10,
																										this.barItem11});
			this.parentBarItem3.Text = "Advanced";
			// 
			// barItem8
			// 
			this.barItem8.CategoryIndex = 2;
			this.barItem8.ID = "Increase Line Indent";
			this.barItem8.ImageIndex = 12;
			this.barItem8.Text = "Increase Line Indent";
			this.barItem8.Click += new System.EventHandler(this.IncreaseIndent);
			// 
			// barItem9
			// 
			this.barItem9.CategoryIndex = 2;
			this.barItem9.ID = "Decrease Indent";
			this.barItem9.ImageIndex = 11;
			this.barItem9.Text = "Decrease Indent";
			this.barItem9.Click += new System.EventHandler(this.DecreaseIndent);
			// 
			// barItem10
			// 
			this.barItem10.CategoryIndex = 2;
			this.barItem10.ID = "Comment Selection";
			this.barItem10.ImageIndex = 9;
			this.barItem10.Text = "Comment Selection";
			this.barItem10.Click += new System.EventHandler(this.CommentLines);
			// 
			// barItem11
			// 
			this.barItem11.CategoryIndex = 2;
			this.barItem11.ID = "Uncomment Selection";
			this.barItem11.ImageIndex = 10;
			this.barItem11.Text = "Uncomment Selection";
			this.barItem11.Click += new System.EventHandler(this.UnCommentLines);
			// 
			// parentBarItem2
			// 
			this.parentBarItem2.CategoryIndex = 1;
			this.parentBarItem2.ID = "Bookmarks";
			this.parentBarItem2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItem4,
																										this.barItem5,
																										this.barItem6,
																										this.barItem7});
			this.parentBarItem2.Text = "Bookmarks";
			// 
			// barItem4
			// 
			this.barItem4.CategoryIndex = 1;
			this.barItem4.ID = "&Toogle Bookmark";
			this.barItem4.ImageIndex = 5;
			this.barItem4.Text = "&Toogle Bookmark";
			this.barItem4.Click += new System.EventHandler(this.AddBookmark);
			// 
			// barItem5
			// 
			this.barItem5.CategoryIndex = 1;
			this.barItem5.ID = "&Next Bookmark";
			this.barItem5.ImageIndex = 6;
			this.barItem5.Text = "&Next Bookmark";
			this.barItem5.Click += new System.EventHandler(this.NextBookmark);
			// 
			// barItem6
			// 
			this.barItem6.CategoryIndex = 1;
			this.barItem6.ID = "&Previous Bookmark";
			this.barItem6.ImageIndex = 7;
			this.barItem6.Text = "&Previous Bookmark";
			this.barItem6.Click += new System.EventHandler(this.PreviousBookmark);
			// 
			// barItem7
			// 
			this.barItem7.CategoryIndex = 1;
			this.barItem7.ID = "&Clear Bookmarks";
			this.barItem7.ImageIndex = 8;
			this.barItem7.Text = "&Clear Bookmarks";
			this.barItem7.Click += new System.EventHandler(this.RemoveBookmark);
			// 
			// bar2
			// 
			this.bar2.BarName = "Text Editor 1";
			this.bar2.Caption = "Text Editor 1";
			this.bar2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.cutItem,
																							  this.copyItem,
																							  this.pasteItem,
																							  this.undoItem,
																							  this.redoItem,
																							  this.comboBoxBarItem1});
			this.bar2.Manager = this.childFrameBarManager1;
			this.bar2.SeparatorIndices.AddRange(new int[] {
															  3});
			// 
			// bar3
			// 
			this.bar3.BarName = "Text Editor 2";
			this.bar3.Caption = "Text Editor 2";
			this.bar3.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItem8,
																							  this.barItem9,
																							  this.barItem10,
																							  this.barItem11,
																							  this.barItem4,
																							  this.barItem5,
																							  this.barItem6,
																							  this.barItem7});
			this.bar3.Manager = this.childFrameBarManager1;
			this.bar3.SeparatorIndices.AddRange(new int[] {
															  2,
															  4});
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// largeImageList
			// 
			this.largeImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.largeImageList.ImageSize = new System.Drawing.Size(32, 32);
			this.largeImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("largeImageList.ImageStream")));
			this.largeImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// editControl
			// 
			this.editControl.Dock = System.Windows.Forms.DockStyle.Fill;
			this.editControl.Name = "editControl";
			this.editControl.SaveOnClose = false;
			this.editControl.Size = new System.Drawing.Size(292, 273);
			this.editControl.StatusBarSettings.EncodingPanel.MinWidth = 0;
			this.editControl.StatusBarSettings.StatusPanel.MinWidth = 70;
			this.editControl.StatusBarSettings.TextPanel.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.editControl.TabIndex = 4;
			this.editControl.Text = "edtCode";
			this.editControl.SaveOnClose = false;
			// 
			// EditorBase
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.undoPopup,
																		  this.editControl});
			this.Name = "EditorBase";
			this.Text = "EditorBase";
			this.Load += new System.EventHandler(this.EditorBase_Load);
			((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager1)).EndInit();
			this.undoPopup.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.editControl)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
		#region APP_LOGIC
		private void InitFromSourceFile()
		{
			if(this.sourceFile != String.Empty)
			{
				FileInfo file = new FileInfo(this.sourceFile);
				//StreamReader r = file.OpenText();
				//if(this.sourceFile.EndsWith(".cs"))
				//	this.editControl.SettingFile = "*CSharp.ini";
				//else if(this.sourceFile.EndsWith(".vb"))
				//	this.editControl.SettingFile = "*VB.ini";
				this.editControl.LoadFile(this.sourceFile);//   Insert(r.ReadToEnd());
				//this.editControl.ActiveView.CaretToTop();
				//this.editControl.CurrentFile = this.sourceFile;
				//r.Close();
				this.Text = file.Name;
			}
			else
				this.editControl.NewFile();
		}
		private void EditorBase_Load(object sender, System.EventArgs e)
		{
			// The SourceFile needs to be set before load gets called.
			this.InitFromSourceFile();
		}

		public string FileName
		{
			get {return this.sourceFile;}
			set
			{
				if(this.sourceFile != value)
				{
					this.sourceFile = value;
					FileInfo file = new FileInfo(this.sourceFile);
					this.Text = file.Name;
				}
			}
		}

		public void SaveAs()
		{
			SaveFileDialog dlg = new SaveFileDialog();
			dlg.Filter = "C# Files (*.cs)|*.cs|VB Files (*.vb)|*.vb|All files|*";
			dlg.FilterIndex = 1;
			if (dlg.ShowDialog() ==  DialogResult.OK)
			{
				this.sourceFile = dlg.FileName;
				Save(this.sourceFile);
			}
			FileInfo file = new FileInfo(this.sourceFile);
			this.Text = file.Name;
		}
		public void Save(string fileName)
		{
			if (fileName != null) 
			{
				try 
				{
					FileStream stream = File.OpenWrite(fileName);
					StreamWriter strWriter= new StreamWriter(stream);
					string strLine;
					for (int i=1; i < this.editControl.Lines.Length; i++)
					{
						strLine = this.editControl.Lines[i];
						strWriter.WriteLine(strLine);// + this.editControl.NewLine);
					}
					strLine = this.editControl.Lines[this.editControl.Lines.Length];
					if (strLine.Length > 0)
					{
						strWriter.WriteLine(strLine);
					}
					strWriter.Close();

					//this.editControl.Modified = false;
				} 
				catch
				{
					MessageBox.Show("Failed to save Read-Only File.");
				}
			}
			else
			{
				MessageBox.Show("No destination file is specified!");
			}
		}

		public virtual void Save()
		{
			if(this.sourceFile != String.Empty)
			{
				Save(this.sourceFile);
			}
			else
			{
				SaveAs();
			}
		}

		private void richTextBox1_TextChanged(object sender, System.EventArgs e)
		{
			this.dirty = true;
		}

		private void find_Click(object sender, System.EventArgs e)
		{
			string srch = ((ComboBoxBarItem)sender).TextBoxValue;
			//this.editControl.ActiveView.FindNext(srch,false);
		}

		private void OnFindReplace(object sender, System.EventArgs e)
		{
			//this.editControl.ActiveView.FindAndReplace(false);
		}

		#region UNDO_LISTBOX
		private void undoPopup_BeforePopup(object sender, System.ComponentModel.CancelEventArgs e)
		{
			int count = this.listBox1.Items.Count > 15 ? 15 : this.listBox1.Items.Count;
			this.listBox1.Height = this.listBox1.ItemHeight * count;
			this.undoPopup.Height = this.listBox1.Height + 26;
			this.undoPopup.PopupHost.OverlapBorderColor = SystemColors.ControlDarkDark;
		}

		private void listBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int index = this.listBox1.IndexFromPoint(e.X, e.Y);
			if(index != -1)
			{
				for(int i = index; i >= 0; i--)
					this.listBox1.SetSelected(i, true);

				for(int i = index + 1; i < this.listBox1.Items.Count; i++)
					this.listBox1.SetSelected(i, false);

				index++;
				this.undoLabel.Text = "Undo " + index.ToString() + " Actions.";
			}
		}

		private void listBox1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			this.undoPopup.HidePopup(PopupCloseType.Done);
		}

		private void label1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			this.undoPopup.HidePopup(PopupCloseType.Deactivated);		
		}
		
		private void undoPopup_CloseUp(object sender, Syncfusion.Windows.Forms.PopupClosedEventArgs args)
		{
			if(args.PopupCloseType == PopupCloseType.Done)
			{
				// Undo Actions here based on selections in the listbox.
			}
		}
		#endregion UNDO_LISTBOX

		private void AddBookmark(object sender, System.EventArgs e)
		{
			//this.editControl.AddBookmark(this.editControl.CurrentLine);
		}

		private void NextBookmark(object sender, System.EventArgs e)
		{
			//this.editControl.ActiveView.GoToLine(this.editControl.NextBookmark(this.editControl.CurrentLine));
			//this.editControl.NextBookmark();
		}

		private void PreviousBookmark(object sender, System.EventArgs e)
		{
			//this.editControl.ActiveView.GoToLine(this.editControl.PreviousBookmark(this.editControl.CurrentLine));
			//this.editControl.PreviousBookmark();
		}

		private void RemoveBookmark(object sender, System.EventArgs e)
		{
			//this.editControl.RemoveBookmark(this.editControl.CurrentLine);
		}

		private void CommentLines(object sender, System.EventArgs e)
		{
			//this.editControl.CommentSelection();
		}

		private void UnCommentLines(object sender, System.EventArgs e)
		{
			//this.editControl.UncommentSelection();
		}

		private void OnUndo(object sender, System.EventArgs e)
		{
			try
			{
				this.editControl.Undo();
			}
			catch
			{}
		}

		private void OnRedo(object sender, System.EventArgs e)
		{
			try
			{
				this.editControl.Redo();
			}
			catch
			{}
		}

		private void OnCut(object sender, System.EventArgs e)
		{
			try
			{
				this.editControl.Cut();//.ActiveView.Cut();
			}
			catch
			{}
		}

		private void OnCopy(object sender, System.EventArgs e)
		{
			try
			{
				this.editControl.Copy();//ActiveView.Copy();
			}
			catch
			{}
		}

		private void OnPaste(object sender, System.EventArgs e)
		{
			try
			{
				this.editControl.Paste();//ActiveView.Paste();
			}
			catch
			{}
		}

		private void IncreaseIndent(object sender, System.EventArgs e)
		{
			//this.editControl.IncreaseLineIndent();
		}

		private void DecreaseIndent(object sender, System.EventArgs e)
		{
			//this.editControl.DecreaseLineIndent();
		}

		private void MultipleUndo(object sender, System.Windows.Forms.MouseEventArgs e)
		{
		
		}

		public bool Dirty
		{
			get{return this.dirty;}
		}
		#endregion APP_LOGIC
	}
}
